#include <vector>
#include <iostream>
#include "regression.h"
#include "classification.h"
#include "gmmClassification.h"
#include "gmmRegression.h"

//#include "json.h" // not needed, avoid potential conflicts with xmm

int main(int argc, const char * argv[]) {
  // insert code here...
  
  regression myNN;
  classification myKnn;
  // gmm classification uses the first element of trainingExample.output as a label
  gmmClassification myGmm;
  // gmm regression uses trainingExample.output as output examples
  gmmRegression myGmr;
  
  std::vector<trainingExample> trainingSet;
  trainingExample tempExample;
  tempExample.input = { 0.2, 0.7 };
  tempExample.output = { 3.0 };
  trainingSet.push_back(tempExample);
  
  tempExample.input = { 2.0, 44.2 };
  tempExample.output = { 20.14 };
  trainingSet.push_back(tempExample);
  
  myGmm.train(trainingSet);
  myGmr.train(trainingSet);
  
  myNN.train(trainingSet);
  //    std::cout << myNN.getJSON() << std::endl;
  std::string filepath = "/var/tmp/modelSetDescription.json";
  myNN.writeJSON(filepath);
  
  regression myNNfromString;
  myNNfromString.putJSON(myNN.getJSON());
  
  regression myNNfromFile;
  myNNfromFile.readJSON(filepath);
  
  std::vector<double> inputVec = { 2.0, 44.2 };
  std::cout << "before: " << myNN.process(inputVec)[0] << std::endl;
  std::cout << "from string: " << myNNfromString.process(inputVec)[0] << std::endl;
  std::cout << "from file: " << myNNfromFile.process(inputVec)[0] << std::endl;
  std::cout << "GMM : " << myGmm.process(inputVec)[0] << std::endl;
  std::cout << "GMR : " << myGmr.process(inputVec)[0] << std::endl;
  
  inputVec = { 0.2, 0.7 };
  std::cout << "GMM : " << myGmm.process(inputVec)[0] << std::endl;
  std::cout << "GMR : " << myGmr.process(inputVec)[0] << std::endl;
  
  return 0;
}
