#ifndef baseModel_h
#define baseModel_h

#include <vector>
#include "trainingSet.h"

/** Base class for wekinator models. Implemented by NN and KNN classes
 */
class baseModel {
public:
  virtual double process(std::vector<double> inputVector) = 0;
  virtual void train(std::vector<trainingExample> trainingSet) = 0;
  virtual int getNumInputs() = 0;
  virtual std::vector<int> getWhichInputs() = 0;
  virtual ~baseModel() {};
};
#endif
