#ifndef xmmModelSet_h
#define xmmModelSet_h

#include "baseModelSet.h"
#include "xmmTool.h"

class xmmModelSet : public baseModelSet {
public:
  xmmModelSet() {}
  ~xmmModelSet() {}

  virtual bool train(std::vector<trainingExample> trainingSet);
  virtual bool initialize();
  virtual std::vector<double> process(std::vector<double> inputVector);

protected:
  xmmToolBase *xmm;

#ifndef EMSCRIPTEN //The javascript code will do its own JSON parsing
public:
  /** Get a JSON representation of the model in the form of a styled string */
  std::string getJSON();
  /** Write a JSON model description to specified file path */
  void writeJSON(std::string filepath);
  /** configure empty model with string. See getJSON() */
  bool putJSON(std::string jsonMessage);
  /** read a JSON file at file path and build a modelSet from it */
  bool readJSON(std::string filepath);
  
private:
  Json::Value parse2json();
  void json2modelSet(Json::Value);
  
#endif
};

#endif /* xmmModelSet_h */

